<div class='row'>

  <form class="container" style='width:480px;margin-top:50px;' #f='ngForm'>
    <h4>Register</h4>

    <input type="text"
      #focusthis
      id="userName"
      name="username"
      class="form-control mt-3"
      placeholder="username (required)"
      required
      minlength="3"
      [(ngModel)]='user_name'
      #u ='ngModel'
    />

    <span
      *ngIf="!u.valid && u.touched"
      class="help-block" style='color:red;'>
      Minimum 4 char required for username!
    </span>

    <br/>
    <input type="password"
      id="password"
      name='password'
      class="form-control"
      placeholder="password (required)"
      required
      minlength=4
      [(ngModel)]='password_hash'
      #p1 ='ngModel'
    />



    <br/>
    <input type="password"
      id="vpassword"
      name='vpassword'
      class="form-control"
      placeholder="verify password (required)"
      minlength=4
      required
      [(ngModel)]='vpassword'
      #p2 ='ngModel'
    />


    <span
      *ngIf="!p1.valid && p1.touched"
      class="help-block" style='color:red;'>
      Minimum 4 char required for password!
    </span>

    <span
      *ngIf="p1.valid && p1.touched && p2.touched && p1.value !== p2.value"
      class="help-block" style='color:red;'>
      Password mismatch.
    </span>

    <br/>
    <input type="email"
      id="email"
      name="email"
      class="form-control"
      placeholder="email"
      [(ngModel)]='email_address'
    />
<!--
    <span
      *ngIf="!e0.valid && e0.touched"
      class="help-block" style='color:red;'>
      Please enter a valid email address.
    </span> -->


    <input type="text"
      #focusthis
      id="firstName"
      name="firstName"
      class="form-control mt-3"
      placeholder= "first name"
      [(ngModel)]='first_name'
    />

    <!-- <span
      *ngIf="!fn.valid && fn.touched"
      class="help-block" style='color:red;'>
      Please enter your first name!
    </span> -->

    <input type="text"
      #focusthis
      id="lastName"
      name="lastName"
      class="form-control mt-3"
      placeholder="last name"
      [(ngModel)]='last_name'
    />
<!--
    <span
      *ngIf="!ln.valid && ln.touched"
      class="help-block" style='color:red;'>
      Please enter your last name!
    </span> -->
    <br/>
    <div class="d-flex float-right mt-1" >
      <button
        class="btn btn-primary"
        [disabled]='!f.valid || p1.value !== p2.value'
        (click)='register()'
      >
        Register
      </button>
    </div>

</form>
</div>

